#@output ImagePlus SEQUENCE
"""This script is supposed to be launched from fiji's jython interpreter
"""

#from ij import IJ  # pylint: disable=import-error

#WHITE_ESTIMATE = IJ.openImage('/Users/graffy/ownCloud/ipr/lipase/lipase.git/white_estimate.tiff')

# # note: fiji's jython doesn't support encoding keyword

# https://imagej.net/Scripting_Headless
# String lipase_src_root_path

# String(label="Please enter your name",description="Name field") name
# OUTPUT String greeting
import sys
print('python version %s' % sys.version)  # prints python version

from lipase.settings import UserSettings

# it is necassary to add lipase's root path to the path if run from fiji as script otherwise jython fails to find lipase's modules such as catalog
# sys.path.append(lipase_src_root_path)  # pylint: disable=undefined-variable

# from lipase import Lipase, ImageLogger
from lipase.preprocessing import test_preprocessing  # noqa: E402 pylint: disable=import-error,wrong-import-position
from lipase.imageengine import IImageEngine
from lipase.imagej.ijimageengine import IJImageEngine
from lipase.preprocessing import WhiteEstimator
from lipase.catalog import ImageCatalog
from lipase.imagej import open_sequence_in_imagej

from ij import IJ
from ij.gui import GenericDialog, DialogListener
from java.awt.event import ItemListener

# def SequenceSelectorDialog(GenericDialog):
#
#    def __init__(self):
#        title = 'select the sequence to process'
#        GenericDialog.__init__(self)

def ask_for_sequence(catalog):
    title = 'select the sequence to process'
    gd = GenericDialog(title)
    # gd.addDialogListener(MyListener())
    sequence_ids = catalog.sequences.keys()
    assert len(sequence_ids) > 0
    default_sequence_id = sequence_ids[0]
    gd.addChoice('sequence', sequence_ids, default_sequence_id)
    choices = gd.getChoices()
    IJ.log("choices = %s" % choices)
    sequence_choice = choices[0]
    gd.showDialog()
    if gd.wasCanceled():
        return {}
    selected_sequence_id = sequence_ids[gd.getNextChoiceIndex()]  # eg 'res_soleil2018/GGH/GGH_2018_cin2_phiG_I_327_vis_-40_1/Pos2'
    print("chosen sequence : %s" % selected_sequence_id)
    return catalog.sequences[selected_sequence_id]


def run_script():
    user_settings = UserSettings()
    IImageEngine.set_instance(IJImageEngine())
    catalog = ImageCatalog(user_settings.raw_images_root_path)
    sequence = ask_for_sequence(catalog)
    if sequence is None:
        return
    sequence_as_stack = open_sequence_in_imagej(sequence)

    print(type(sequence_as_stack))
    global SEQUENCE
    SEQUENCE = sequence_as_stack

# note : when launched from fiji, __name__ doesn't have the value "__main__", as when launched from python
run_script()
